<?php
require_once( STRIPE_BASE_DIR . '/lib/Stripe.php' );
class StripeAPIModel{
  public function create_remote_stripe_customer( $controller )
  {
    try
    {
      $controller->debug( 'create_remote_stripe_customer( $controller )' );
      $controller->authenticate_stripe( $controller );
      if (is_user_logged_in()) {
        // check to see if the user has _stripe_customer_id set
        $controller->set_stripe_customer( Stripe_Customer::create( array(
          'card' => $controller->get_stripe_token())));
      } else {
        // if not create a customer on the Stripe server.
        $controller->get_remote_stripe_customer( $controller );
      }
    } catch( Exception $e ) {
      throw( $e );
    }
  }
  /***************************************************************************
   * get_remote_stripe_customer( $controller )                               *
   *                                                                         *
   * Retrieve Stripe_Customer from Stripe and store it locally. This function*
   * expects $controller to implement get_customer_id() which should return  *
   * the Stripe_Customer::Id of the record that we want to retrieve.         *
   * *************************************************************************/
  public function get_remote_stripe_customer( $controller ){
    $controller->debug( 'get_remote_stripe_customer( $controller )' );
    $controller->authenticate_stripe( $controller );
    $controller->debug( 'sucka' );
    $stripe_customer_id = $controller->get_customer_id();
    $controller->debug( 'fool' );
    $stripe_customer = Stripe_Customer::retrieve( $stripe_customer_id );
    $controller->debug( 'got stripe_customer' );
    return $stripe_customer;
  }
  public function get_last_charge( $controller ){
    $controller->authenticate_stripe( $controller );
    // get most recent charge to this customer
    $stripe_charges = Stripe_Charge::all(array(
      "count" => 1,
      "customer" => $controller->get_customer_id()
    ));
    // retrieve array of charges from returned data structure
    $charges = $stripe_charges->data;
    // grab the first element of the array (i.e. the last charge)
    $last_charge = array_shift($charges);
    return( $last_charge );
  }
  /***************************************************************************
   * authenticate_stripe( $controller )                                      *
   * *************************************************************************/
  public function authenticate_stripe( $controller ){
    $controller->debug( 'authenticate_stripe( $controller )' );
    if ( $controller->is_stripe_authenticated() ){
      return;
    } else {
      $controller->debug( 'controller not authenticated with Stripe' );
      $secret_key = $controller->get_stripe_option( 'test_mode' ) 
                  ? $controller->get_stripe_option( 'test_secret_key' )
                  : $controller->get_stripe_option( 'live_secret_key' );
      Stripe::setApiKey($secret_key);
      $controller->stripe_is_authenticated();
      $controller->debug( 'Stripe is authenticated' );
    }
  }
  /***************************************************************************
   * charge_customer( $customer_id, $amount )                                *
   ***************************************************************************/
  public function charge_customer( $controller )
  {
    try 
    {
    $controller->debug( 'charge_customer( $controller )' );
    $controller->authenticate_stripe( $controller );
    $controller->debug( 'next' );
    $charge = Stripe_Charge::create(array(
      'amount' => $controller->get_amount(),
      'customer' => $controller->get_customer_id(),
      'currency' => 'usd'
    ));
    $controller->debug( 'next1' );
    } catch( Exception $e ){
      $controller->debug( $e );
      exit();
    }
  }
  public function set_remote_stripe_email( $controller ){
    $controller->debug("set_remote_stripe_email()");
    $stripe_customer = $controller->get_stripe_customer();
    if ( (!isset($stripe_customer->email)) 
      || ($stripe_customer->email !== $controller->get_customer_email() ) )
    {
      $stripe_customer->email = $controller->get_customer_email();
      $stripe_customer->save();
    }
  }
}
?>
